// ----------------------------------------------------------------------------
// ...\Hello\Main.pas
//
// Purpose:
//   Main form. Simple example of Delphi app with text box, buttons and
//   basic variables.
//
// Created:
//   2018-07-21  Foersom
//
// License: CC-BY 4.0
// ----------------------------------------------------------------------------

unit Main;

interface  // -----------------------------------------------------------------


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TMainForm = class(TForm)
    OutputMemo: TMemo;
    ActionButton: TButton;
    ExitButton: TButton;
    TimeButton: TButton;
    ShowMessageButton: TButton;
    procedure ActionButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OutputMemoWriteln(s: string);
    procedure TimeButtonClick(Sender: TObject);
    procedure ShowMessageButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Count: integer;
  end;

var
  MainForm: TMainForm;

implementation  // ------------------------------------------------------------

{$R *.dfm}

procedure TMainForm.OutputMemoWriteln(s: string);
begin
  // Write a line in text box (memo control)
  OutputMemo.Lines.Add(s);
end;

procedure TMainForm.ActionButtonClick(Sender: TObject);
begin
  inc(Count);
  OutputMemoWriteln(format('Hello %d',[Count]));
end;

procedure TMainForm.ShowMessageButtonClick(Sender: TObject);
begin
  ShowMessage('Hello World!');
end;

procedure TMainForm.TimeButtonClick(Sender: TObject);
var
  S: string;
begin
  S:=FormatDateTime('hh:nn:ss.zzz',now);
  OutputMemoWriteln('Time: '+S);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // Window is created, starts here
  OutputMemo.Lines.Clear;
  OutputMemoWriteln('Bonjour, Hallo, Hello');
  Count:=0;
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  // Close main form to close app
  Close;

  // Alternative:
  //  Application.terminate;
end;

end.

